#ifndef PARAMETERMANAGER_H
#define PARAMETERMANAGER_H

#include <iostream>
#include <getopt.h>
#include <string.h>
#include <sstream>
#include <sys/stat.h>
#include <fstream>
#include <limits.h> // PATH_MAX
#include <unistd.h> // readlink()
#include <vector>

#ifdef _WIN32
#include <windows.h>
#endif

enum Modus {
    EXIT = -1,
    DEFAULT_MODUS = 0,
    DIRECT_LINK_MODUS = 1,
    SEARCH_MODUS = 2,
    INFO_MODUS = 3

};


struct Settings {
    Settings() {}
    Settings(std::string name) : name(name) {}

    std::string name,
        accountFilePath = "/tmp/a",
        accountNumberPath= "/tmp/a_n",
        cookieFilePath  = "/tmp/S_New4_cookies",
        serienListPath = "/tmp/SerienListe",
        defaultsFilePath = "/tmp/defaults",
        proxy_ip = "127.0.0.1",
        languages = "GerDub,GerSub,Eng",
        genaueHoster = "",
        version = "2.4.4",
        defaultFileVersion="1.3",
        outputFilePath = "",
        default_checkPath = "",
        default_Searchmuster = "S%Staffel%E%Folge%";

    Modus modus = Modus::DEFAULT_MODUS;
    bool colorless = false,
         debugMode = false,
         search_IgnoreUpperLower = true,
         search_wantUpdate = false;
    int startEpisode = 1,
        stopEpisode = 0,
        startSeason = 1,
        stopSeason = 0,
        proxy_port = 9050,
        default_maxDirs = 20;
    char pathSymbol = '/';
    unsigned maxThreads = 0;

};

int manageParameter(Settings &settings, int argc, char ** argv);
int loadDefaulOptions(Settings & settings);
std::vector<std::string> compare(std::string All_Options_with_komma_between, std::string input);

std::string getProgramName();
std::string getexepath();

void setPathSymbol(Settings &settings);
void setPaths(Settings &settings);

bool fileExists (const std::string& name);
bool dirExists(std::string dir);
bool nothingExists(std::string path);

int unterOption_help();

int unterOption_default(Settings * settings, int argc, char **argv);
void unterOption_default_help();

int unterOption_url(Settings * settings, int argc, char **argv);
void unterOption_url_help();

int unterOption_search(Settings * settings, int argc, char **argv);
void unterOption_search_help();

int unterOption_info(Settings * settings, int argc, char **argv);
void unterOption_info_help();

void unterOption_clean(Settings * settings, int argc, char **argv);


#endif // PARAMETERMANAGER_H
